function H = jointEntropy(X)

[row,D]  = size(X);

[X0,idx,cid] = unique(X,'rows');

L = length(idx);
P = zeros(L,1);
for i = 1:row
    P(cid(i)) = P(cid(i))+1;
end

P = P/row;

H = - sum(P.*log2(P));


end