clear;
clc;
 epi_dim = 2;
 Dim = 1000;
threshold=0.1;

startIndex=1;
endIndex=100;
 folder = '.\reslutData\';

                model='Model-3';parameter='H2=0.02,PD=0.1,MAF=0.05';MAF = 0.05;
                 filepath='dataset\1000SNP\1_EDM-1\1_EDM-1_';
          
        
       FunctionSNP = [Dim-epi_dim+1 : Dim];
     succFindNumber =0;
        TP = 0;
                TN = 0;
                FP = 0;
                FN = 0;
     
                 

                 
                 if   isequal(model,'Model-1') 
                     pvalue = 0.01/nchoosek(Dim,epi_dim)/MAF;  
                 elseif isequal(model,'Model-2')  
                     pvalue = (1e-4)/nchoosek(Dim,epi_dim)/MAF;   
                 elseif isequal(model,'Model-3')  
                     pvalue =  (1e-7)/nchoosek(Dim,epi_dim)/MAF;  
                 end
        for dataSetId = startIndex:endIndex
             if dataSetId<10
                noId = strcat('00',num2str(dataSetId));
             elseif dataSetId<100
                noId = strcat('0',num2str(dataSetId));
             else
                noId = num2str(dataSetId);
             end
             
    %% read data set
                    % data = dlmread(strcat(filepath,noId,'.txt'),',',0,0);
          data = dlmread(strcat(filepath,noId,'.txt'),'\t',1,0);
           [row,col]= size(data);
%%
            col = col - 1;
            su = zeros(1,col);
            hx = zeros(1,col);
            R = hx ; %% revelance
            hy = entropy(data(:,col+1));
            state = data(:,col + 1);
            S = [];
            findFlag = 0;
            testFlag = 0;
            F = 1:col;
            k = 0;
            tm = 2; % tm
            K = epi_dim;
            w = ones(1,col);
              tw  = w ;
                for i = 1:col
                    %hx(i) = entropy(data(:,i));
                    %su(i) = SU(data(:,i),state, hx(i), hy);  %% ԳƲȷ ׼
                    Hxy(i) =jointEntropy(data(:,[i,col+1]))+hx(i);
                    su(i) = SU2(data(:,i),state, Hxy(i));  
                end
                %% recursion 
                
                
              su2 = su; 
                CandidateSize =4;       
               S = [];
     
            F = 1:col;
            w(1:col) = 1;
            k = 0;
              selSize = 0;
              Candidate = [];
              finalResults = [];
                tic;
              while selSize<CandidateSize
                  if ~isempty(Candidate)
                      CsSize = length(Candidate(:,1));
                  else
                      CsSize = 0;
                  end
                   Candidate = iwf(S,w,K,su2,tm,F,data,state,Candidate);
                   selSize = selSize + length(Candidate(:,1)) - CsSize;
%                      w(Candidate(CsSize+1,1:tm)) = 0;
                       w(Candidate(1:length(Candidate(:,1)),1)) = 0;
              end
                
            time = toc;

             fprintf(' data ID %d:  ',dataSetId ); 
                r = 1;
              while r < CandidateSize %length(Candidate(:,1))
                 S = Candidate(r,:);
                       S = sort(S);
                    if isequal(S, FunctionSNP)
                        findFlag = 1;
                        succFindNumber = succFindNumber + 1;
                        fprintf('    In the first stage, find successfully %d/100 , runtime = %f;    ', succFindNumber, time);

                    end
                   
                  %  T = 1e+5;
                        [P_value] = Gtest_score(data(:,S),data(:,Dim+1));
%                          [P_value] = permutation(data(:,S),data(:,Dim+1),T,1/T);% permutationTest(data(:,S), data(:, Dim+1));
                %       [P_value,~] = Chi_square2(data(:,S),data(:,Dim+1));
                     if P_value < pvalue
                            [P_value2] = permutation(data(:,S),data(:,Dim+1),100,pvalue);
                            if P_value2 < 0.01
                                 if isequal(FunctionSNP,S)
                                     TP = TP + 1;
                                     testFlag = 1;
                                    FunSNP_pvalue = P_value;
                                  %    fprintf(' functional SNPs  pvalue = %10.5e\n', P_value); 
                                 else
                                     FP = FP + 1; 
                                     fprintf('              find a false positive SNP combination (%d  %d), false positive pvalue = %10.5e  , runtime = %f\n',S, P_value, time); 
                                 end
                            end
                     else
                          if isequal(FunctionSNP,S)
                             FN = FN + 1;
                             FunSNP_pvalue = P_value;
                            %  fprintf(' functional SNPs  pvalue = %10.5e\n', P_value); 
                         end
                     end
                     
                     r = r + 1;
                     
              end
                
                      if findFlag == 1                                       
                                     %   fprintf('Mode%d     | ---  data%2d :    found successfully            have found : %2d/100 , consume time:%10.2f(s), sortId=%d', dataIndex, dataSetId, succFindNumber ,time ,r);
                                        if testFlag == 1
                                            fprintf(' VV    FunSNP_pvalue=%e,   pass the testing  of G-test  VV  \n', FunSNP_pvalue);
                                        else
                                            fprintf(' !!    functional SNPs pvalue=%e,   failed pass the testing!! \n', FunSNP_pvalue);
                                        end
                      else
                                 
                                      %  fprintf('    search failed in the first stage,   !!!!!         \n', dataIndex, dataSetId);
                                        % Candidate
               end
              
          
              % toc
               %Candidate
        end
             TN = nchoosek(Dim, epi_dim) - FP;
               
               recall = TP / (TP + FN);
               precision = TP / (TP + FP);
               F_measure = 2 /( 1/recall + 1/precision);
               sensitivity = recall;
               specificity = TN/(TN + FP);
               power = succFindNumber;
               fprintf(' Power =%d, recall = %f, precision=%f, f-measure = %f : TP=%f, FP=%f, TN =%f, FN=%f \n', power, recall, precision, F_measure, TP, FP, TN, FN);
 
             %  filename = strcat('model',num2str(dataIndex));
  dataFile = 'resultData\Result1000SNP_0.01.xls'
         
   ResultName={'power','recall',	'prec',	'f-measure',	'sensitivity',	'specificity',	'#TP',	'#FP',	'#TN',	'#FN',	'RUNTIME'};
    Results=[power, recall, precision, F_measure, sensitivity, specificity, TP, FP, TN, FN,time];
    
   
   sheet = 1;
   xlswrite(dataFile,ResultName,sheet,'B1')
    xlswrite(dataFile,Results,sheet,'B2')

   