function candidate = iwf(S,w,K,SU,m,F,data,state,candidate)
  
         R = w.*(1+SU); % Calculate the adjusted relevance measure
         [sR,sind] = sort(R,'descend');
         
         for k = 1:m
             
              FJ = [S,F(sind(k))];
                         w(sind(k)) = 0;
                          for i = 1:length(F)
                                        IWF(i) = interactionWeightFactor(data(:,F(i)), data(:,FJ),state);
                                         ME(i) = mutualEntropy([data(:,F(i)), data(:,FJ)],state);
                          end
                          IWF = ( IWF - min(IWF)) / ( max(IWF) - min(IWF));
                          ME = ( ME - min(ME)) / (max(ME) - min(ME));
                          w= w.*(IWF + ME);
                   
                   if length(FJ) == K
                       candidate = [candidate; FJ];
                   else
                       candidate =  iwf(FJ,w,K,SU,m,F,data,state,candidate);
                   end
                
         end
       
end